/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor button.c */

#include <unistd.h>
#include <stdlib.h>
#include <semaphore.h>

#include "strukturyw.h"
#include "box3.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

sem_t button_semafor;
int button_navrat;


int button_semafor_init(void)
{
    return sem_init(&button_semafor, 0, 1);
}

int button_semafor_destroy(void)
{
    return sem_destroy(&button_semafor);
}

int button_wait(int test)
{
    if (test == 1) {
        return sem_wait(&button_semafor);
    } else {
        return sem_post(&button_semafor);
    }
}

void button_vytiskni_text(WINDOW * new_zprava,
                          short int *ypozice, short int *zpozice,
                          char *zprava)
{
    wprintw2(new_zprava, zprava);
}

/* navratova hodnota buttonu je 0 pri chybe, jinak cislo pozky 1 .. POC-1 */
int button(char **zprava, int POC, int radka, int ydelk, int xdelk,
           int ykam, int xkam)
{                               /* POC je pocet sprav;
                                   radka je "rozsvicena" radka */
    WINDOW *new_zprava;
    int ch;
    short int vyber, ypozice, zpozice;
    while (button_wait(1));

    if ((new_zprava = newwin2(ydelk, xdelk, ykam, xkam)) == NULL) {
        print_hl(1, "CHYBA: Nelze zobrazit button!");
        if (global_get(g_warning) == g_w_ano)
            perror("button()");
        return 0;
    }

    wattron2(new_zprava, COLOR_PAIR(COLOR_BUTTON_HLAVNI));

    /*    werase2(new_zprava); */
    for (ypozice = 0; ypozice < ydelk; ypozice++)
        for (zpozice = 0; zpozice < xdelk; zpozice++)
            mvwaddch2(new_zprava, ypozice, zpozice, ' ');

    pridej_do_priority_w(1, new_zprava, stdscr, LINES - 1, 0);
    do {
        ypozice = 1;
        zpozice = 1;
        wmove2(new_zprava, ypozice, zpozice);
        for (vyber = 0; vyber < POC; vyber++) {
            if (vyber == radka)
                wattron2(new_zprava, A_BOLD);
            button_vytiskni_text(new_zprava, &ypozice, &zpozice,
                                 zprava[vyber]);
            if (vyber == radka)
                wattroff2(new_zprava, A_BOLD);
        }
        box3(new_zprava, '|', '*');
        if ((POC > 2) && (xdelk >= 12)) /* aby se to tam veslo */
            mvwprintw2(new_zprava, ydelk - 1, xdelk / 2 - 6,
                       xdelk % 2 ? "<-f--***--j->" : "<-f--**--j->");
        tiskni_dle_priority();
        ch = getch3();

        if (ch == '\n')
            break;
        if ((ch == KEY_RIGHT) || (ch == 'j')) {
            if (radka < POC - 1)
                radka++;
            else
                radka = 1;
        } else if ((ch == KEY_LEFT) || (ch == 'f')) {
            if (radka > 1)
                radka--;
            else
                radka = POC - 1;
        }
    }
    while (TRUE);

    odeber_z_priority(new_zprava);
    delwin2(new_zprava);
    tiskni_dle_priority();

    button_wait(0);
    return radka;
}
