/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor global.c */

#include <stdlib.h>
#include <semaphore.h>
#include "struktury.h"
#include "lib.h"

static sem_t globalsem;

int global_semafor_init(void)
{
    return sem_init(&globalsem, 0, 1);
}

int global_semafor_destroy(void)
{
    return sem_destroy(&globalsem);
}

#undef GSEM

static short int priznaky[8];   /* inicializuje se v argumenty.c a prihlaseni.c */

short int global_get(enum_global priznak)
{

    switch (priznak) {
    case g_barva:
        return priznaky[0];
    case g_warning:
        return priznaky[1];
    case g_qwertz:
        return priznaky[2];
    case g_us:
        return priznaky[3];
    case g_run:
        return priznaky[4];
    case g_box:
        return priznaky[5];
    case g_disable_inet:
        return priznaky[6];
    default:
        return 0;
    }
}

void global_set(enum_global priznak, short int stav)
{
    while (sem_wait(&globalsem));
    switch (priznak) {
    case g_barva:
        /* barva == 0 defaultni schema,
           barva == <1-6>; jednobarevne schema,
           barva == 7 cernobile schema, ... */
        priznaky[0] = stav;
        break;
    case g_warning:
        priznaky[1] = stav;     /* kdyz stav, tak warovani */
        break;
    case g_qwertz:
        priznaky[2] = stav;     /* y = 0, z = 1 */
        break;
    case g_us:
        priznaky[3] = stav;     /* u = 1, c = 0 */
        break;
    case g_run:
        priznaky[4] = stav;
        /*   0 = nic; 1 = lekce; 2 = test; */
        break;
    case g_box:
        priznaky[5] = stav;
        /*   0 = pouzij spec. znaky jako je ACS_VLINE; 1 = pouzij '-' atd. */
        break;
    case g_disable_inet:
        priznaky[6] = stav;
        /*   0 = pouzij spec. znaky jako je ACS_VLINE; 1 = pouzij '-' atd. */
        break;
    }
    sem_post(&globalsem);
}
