/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor pisradek.c */

#include <stdlib.h>
#include <time.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"
#include "utils.h"

int
pis_radek(unsigned int *vterin,
          char *radek, int radku, unsigned int *znak, unsigned int *chyb,
          int mezernik, boolean nezobraz_radek)
{
    int i, ch, priznak;
    struct timespec ts1, ts2;
    char pom[2];
    unsigned char ukonceni[3];
    char *anone[] =
        { " OPRAVDU CHCE SKONIT?\n\n", "   < Ano >", "    < Ne  >" };

    i = 0;
    priznak = 0;
    pom[1] = '\0';
    ukonceni[0] = UKONCENIRADKU;
    ukonceni[1] = mezernik ? UKONCENIRADKU : '\0';
    ukonceni[2] = '\0';

    pridej_do_priority_w(1, sub_psani, sub_psani,
                         radku < LINES - 15 ? radku : LINES - 15, i + 1);

    clock_gettime(CLOCK_MONOTONIC, &ts1);
    ts2 = ts1;
    do {
#ifndef _ZOBRAZRADKUTESTU
        if (!nezobraz_radek) {
#endif
            obnov_radek1(radek, i, *znak, radku, *chyb, *vterin + difftimespec(&ts2, &ts1),
                         mezernik);
#ifndef _ZOBRAZRADKUTESTU
        } else {
            obnov_radek1("", 0,
                         *znak, radku, *chyb, *vterin + difftimespec(&ts2, &ts1),
                         mezernik);
        }
#endif
        obnov_psani();
        odeber_z_priority(sub_psani);
        pridej_do_priority_w(1, sub_psani, sub_psani,
                             radku < LINES - 15 ? radku : LINES - 15,
                             i + 1);

        tiskni_dle_priority();
        ch = getch3();
        clock_gettime(CLOCK_MONOTONIC, &ts2);
        if (ch == KEY_BACKSPACE) {
            if (global_get(g_run) == g_run_t) {
                print_hl(1, "Psan testu nelze peruit.");
                continue;
            } else if (button(anone, 3, 2, 5, 26, 10, 25) == 1) {
                wattroff2(sub_psani, A_REVERSE);
                wattron2(sub_psani, COLOR_PAIR(COLOR_SUB_PSANI));
                odeber_z_priority(sub_psani);
                return 1;
            } else
                continue;
        }
        if ((char) ch != radek[i]       /* spatne napsane pismenko */
            &&!((ch == ' ') && (radek[i] == '\n') && mezernik)) {
            printf("\a");
            wattron2(sub_psani, A_REVERSE);
            wattron2(sub_psani, COLOR_PAIR(COLOR_RADEK_CHYBA));

            if (radek[i] != '\n') {
                pom[0] = radek[i];      /* funkce waddch2 nespracuje hacky .. */
                wprintw2(sub_psani, pom);
            } else {
                mvwprintw2(sub_psani,
                           radku < LINES - 15 ? radku : LINES - 15,
                           COLS - 4, (char *) ukonceni);
            }

            obnov_psani();
            if (!priznak)
                (*chyb)++;
            priznak = 1;
            continue;
        }
        /* dobre napsane pismenko */
        /* novy radek  -> ukonceni funkce pisradek */
        if ((radek[i] == '\n') && (ch == ' ' || ch == '\n')) {

            if (radku < LINES - 15) {
                mvwprintw2(sub_psani, radku, COLS - 4, (char *) ukonceni);
            } else {
                mvwprintw2(sub_psani,
                           radku < LINES - 15 ? radku : LINES - 15,
                           COLS - 4, (char *) ukonceni);
            }
            if (priznak) {      /* chyby */
                priznak = 0;
                wattroff2(sub_psani, A_REVERSE);
                wattron2(sub_psani, COLOR_PAIR(COLOR_SUB_PSANI));
            }
            /* odradkovani textu */
            if (radku >= LINES - 15) {
                mvwprintw2(sub_psani, LINES - 15, COLS - 1, "\n\n");
                MVWPRINTW2(sub_psani, LINES - 15, 0, "%*c", COLS, ' ');
            }

            (*znak) += hodnota_znaku(radek[i]);
            break;
        }
        pom[0] = (char) ch;
        wprintw2(sub_psani, pom);

        if (priznak) {          /* chyby */
            priznak = 0;
            wattroff2(sub_psani, A_REVERSE);
            wattron2(sub_psani, COLOR_PAIR(COLOR_SUB_PSANI));
        }
        (*znak) += hodnota_znaku(radek[i]);
        i++;
    }
    while (1);

    (*vterin) += difftimespec(&ts2, &ts1);

    obnov_radek1("", -1, *znak, radku, *chyb, *vterin, mezernik);
    odeber_z_priority(sub_psani);
    return 0;
}
